﻿
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Linq;

namespace XamMenuTest
{

    public class PluginViewModel 
    {
        public PluginViewModel()
        {


            //Mock-up logic creating Carriers and Tasks in the "Plugin Selector" control.
            //TODO: This will need to be replaced by MEF (Importing available plugins)
            Carrier c = new Carrier { Name = "DHL" };


            ObservableCollection<Rate> rates = new ObservableCollection<Rate>();
            rates.Add(new Rate{ RateName = "Base Rate"});
            rates.Add(new Rate{ RateName = "Fuel Surcharge"});

            ObservableCollection<Service> services = new ObservableCollection<Service>();
            services.Add(new Service{ ServiceName = "Standard Service", Rates=rates});
            services.Add(new Service{ ServiceName = "Expedited Service", Rates=rates});

            c.Services = services;

            Carriers = new ObservableCollection<Carrier>();
            Carriers.Add(c);
            Carriers.Add(new Carrier { Name = "Empty Carrier" });
            //END mock-up
        }

        private ObservableCollection<Carrier> carriers;

        public ObservableCollection<Carrier> Carriers
        {
            get { return carriers; }
            set { carriers = value; }
        }


        //Nested class
        public class Carrier
        {
            private string name;

            private ObservableCollection<Service> services;

            public string Name
            {
                get { return name; }
                set { name = value; }
            }

            public ObservableCollection<Service> Services
            {
                get { return services; }
                set { services = value; }
            }

        }


        //Nested class
        public class Service
        {
            private string serviceName;
            private ObservableCollection<Rate> rates;

            public string ServiceName
            {
                get { return serviceName; }
                set { serviceName = value; }
            }

            public ObservableCollection<Rate> Rates
            {
                get { return rates; }
                set { rates = value; }
            }


        }

        //Nested class
        public class Rate
        {
            private string rateName;

            public string RateName
            {
                get { return rateName; }
                set { rateName = value; }
            }
        }
    }


}
